#include <iostream>
#include <fstream>
#include <string>
#include <cmath> // abs()

// some errors were caused by a dumb lack of abs() in the diff calculation

using namespace std;

ofstream debuglog;
ofstream colorchecklog;

// ios binary means DON'T try and fix unix line endings / etc.

struct RGB
{
    unsigned char R;
    unsigned char G;
    unsigned char B;
};

struct Pal
{
    RGB Colors[256];
};

struct PLAYPAL
{
    Pal Palettes[14];
};

// add file open error
PLAYPAL ReadPaletteFile(string iFileName)
{
    PLAYPAL tPal;
    ifstream infile;
    infile.open(iFileName.c_str(), ios::binary);
    if(!infile)
    {
        debuglog << "Error: Could not read " << iFileName << endl;
    }
    infile.read((char*)&tPal, sizeof(PLAYPAL));
    debuglog << "sizeof(PLAYPAL) is " << sizeof(PLAYPAL) << endl;

    return tPal;
}

bool WritePaletteFile(PLAYPAL iPal, string iFileName)
{
    ofstream tempfile;
    tempfile.open(iFileName.c_str(), ios::binary);
    if(!tempfile)
    {
        return false;
    }

    tempfile.write((char*)&iPal,sizeof(PLAYPAL));
    return true;
}

void PrintRGB(RGB iRGB)
{
    debuglog << "R is " << (int) iRGB.R << endl;
    debuglog << "G is " << (int) iRGB.G << endl;
    debuglog << "B is " << (int) iRGB.B << endl;
    return;
}

struct ColorMapRow
{
    int Indexes[34];
};

struct RGBColorMapRow
{
    RGB Colors[34];
};

void PrintColorMapRow(ColorMapRow iColorMapRow)
{
    for(int i = 0; i < 34; i++)
    {
        debuglog << "Colormaprow[" << i << "] == " << iColorMapRow.Indexes[i] << endl;
    }

    return;
}

void LogColorMapRow(ColorMapRow iColorMapRow)
{
    debuglog << "----LogColorMapRow----" << endl;
    for(int i = 0; i < 34; i++)
    {
        debuglog << "Colormaprow[" << i << "] == " << iColorMapRow.Indexes[i] << endl;
    }

    return;
}

void LogRGBColorMapRow(RGBColorMapRow iColorMapRow)
{
    colorchecklog << "----LogRGBColorMapRow---" << endl;
    for(int i = 0; i < 34; i++)
    {
        colorchecklog << '[' << i << "]: {" << (int) iColorMapRow.Colors[i].R << ',' << (int) iColorMapRow.Colors[i].G << ',' << (int) iColorMapRow.Colors[i].B << '}' << endl;
    }

    return;
}

struct RGBFloat
{
  float R;
  float G;
  float B;
};

class RGBFloatStep
{
    public:
    float R;
    float G;
    float B;

    RGB ReturnValue(RGB iRGB, int index)
    {
        RGBFloat tRGB;
        tRGB.R = (float)iRGB.R - R*index;
        tRGB.G = (float)iRGB.G - G*index;
        tRGB.B = (float)iRGB.B - B*index;

        if(tRGB.R < 1)
            tRGB.R = 0;

        if(tRGB.G < 1)
            tRGB.G = 0;

        if(tRGB.B < 1)
            tRGB.B = 0;

        RGB tRGB_ret;
        tRGB_ret.R = (unsigned char) tRGB.R;
        tRGB_ret.G = (unsigned char) tRGB.G;
        tRGB_ret.B = (unsigned char) tRGB.B;

        return tRGB_ret;
    }

    void Calculate(RGB iRGB, int iNumberOfSteps)
    {
        R = iRGB.R / iNumberOfSteps;
        G = iRGB.G / iNumberOfSteps;
        B = iRGB.B / iNumberOfSteps;
    }
};
// NOTE, this fills in dummy (white) values for 33 and 34

// TODO: Replace dummy values with reasonable invulnerability colors!

// need to fix tStep.ReturnValue, color 1 is just 11111111111111111111111111111111 all the way down.

RGBColorMapRow MakeRGBGradient(RGB iColor1)
{
    RGBColorMapRow tColorMapRow;
    RGBFloatStep tStep;

    tStep.Calculate(iColor1,34);

  //  tStep = CalcStep(iColor1, 32);

    for(int i = 0; i < 32 ; i++)
    {
        tColorMapRow.Colors[i] = tStep.ReturnValue(iColor1,i);
    }

    tColorMapRow.Colors[32].R = 255;
    tColorMapRow.Colors[32].G = 255;
    tColorMapRow.Colors[32].B = 255;

    tColorMapRow.Colors[33].R = 255;
    tColorMapRow.Colors[33].G = 255;
    tColorMapRow.Colors[33].B = 255;


    return tColorMapRow;
}

// this method is what is used to convert pngs to doom palette images
// in Slade 3, by Sirjuddington. This function has been modified from
// what it was in Slade 3 to fit the data structures of this program.
int FindNearestIndex(RGB iRGB, Pal iPalette)
{
    colorchecklog << "----------START FindNearestIndex---------" << endl;
    colorchecklog << "iRGB.R = " << (int) iRGB.R << endl;
    colorchecklog << "iRGB.G = " << (int) iRGB.G << endl;
    colorchecklog << "iRGB.B = " << (int) iRGB.B << endl;


	int tMin_Diff = 999999;
	int tBestMatchIndex = 0;
	int tDiff;
	RGB tRGB_Delta;

	for (int i = 0; i < 256; i++)
	{
		tRGB_Delta.R = abs(iRGB.R - iPalette.Colors[i].R);
		tRGB_Delta.G = abs(iRGB.G - iPalette.Colors[i].G);
		tRGB_Delta.B = abs(iRGB.B - iPalette.Colors[i].B);
		tDiff = (tRGB_Delta.R*tRGB_Delta.R)+(tRGB_Delta.G*tRGB_Delta.G)+(tRGB_Delta.B*tRGB_Delta.B);

		// If the current color in PLAYPAL is an exact match with iRGB,
		// return the index of that current color.
		if (tDiff == 0)
		{
			tBestMatchIndex = i;
			//colorchecklog << "Exact match found with index " << tBestMatchIndex << endl;
		    //colorchecklog << "With RGB {" << (int)iPalette.Colors[i].R << ',' << (int)iPalette.Colors[i].G << ',' << (int)iPalette.Colors[i].B << '}' << endl << endl;

			return tBestMatchIndex;
		}

		else if (tDiff < tMin_Diff)
		{
		    //colorchecklog << "Best Match updated " << endl;
		    //colorchecklog << "Was tBestMatchIndex = " << (int)tBestMatchIndex << " with tMin_Diff of " << (int)tMin_Diff << endl;
		    //colorchecklog << "Updated to " << (int)i << " with tDiff of " << (int)tDiff << endl;
		    //colorchecklog << "With RGB {" << (int)iPalette.Colors[i].R << ',' << (int)iPalette.Colors[i].G << ',' << (int)iPalette.Colors[i].B << '}' << endl << endl;
			tMin_Diff = tDiff;
			tBestMatchIndex = i;
		}

		//colorchecklog << "index " << i << endl;
        //colorchecklog << "With RGB {" << (int)iPalette.Colors[i].R << ',' << (int)iPalette.Colors[i].G << ',' << (int)iPalette.Colors[i].B << '}' << endl;
       // colorchecklog << "diff = " << (int) tDiff << endl << endl;
	}
	// we have not found any perfect matches to iRGB, and we have
	// went through the entire palette. Return the best match we've found.
	return tBestMatchIndex;
}

// what if it checked twice for matches, one that was close to the color it is currently
// and again for a more muted color? i'm not sure.

// problem is it won't decrease if it's weighted; it will just take the same value repeatedly.

// I see you cheating varmint!

// A custom find nearest index implementation that tries to find
// a better match in coloration (hopefully avoiding brownish darker colors).

// if the color is mostly red, blue, green, whatever,
// try to pick color matches that are closer to the most intense color.
int FindNearestIndexAlt(RGB iRGB, Pal iPalette)
{
    //colorchecklog << "----------START Magickal FindNearestIndex---------" << endl;
    //colorchecklog << "iRGB.R = " << (int) iRGB.R << endl;
    //colorchecklog << "iRGB.G = " << (int) iRGB.G << endl;
    //colorchecklog << "iRGB.B = " << (int) iRGB.B << endl;


	int tMin_Diff = 999999;
	int tBestMatchIndex = 0;
	float tDiff;
	RGB tRGB_Delta;

    float tRGB_Magicke_R;
    float tRGB_Magicke_G;
    float tRGB_Magicke_B;

    float tRGB_Total;

    //iRGB [0]: {0,0,83}

	for (int i = 0; i < 256; i++)
	{
		tRGB_Delta.R = abs(iRGB.R - iPalette.Colors[i].R);
		tRGB_Delta.G = abs(iRGB.G - iPalette.Colors[i].G);
		tRGB_Delta.B = abs(iRGB.B - iPalette.Colors[i].B);

		tRGB_Total = (float)iRGB.R + (float)iRGB.G + (float)iRGB.B;

		tRGB_Magicke_R = 1 - iRGB.R/tRGB_Total;
		tRGB_Magicke_G = 1 - iRGB.G/tRGB_Total;
		tRGB_Magicke_B = 1 - iRGB.B/tRGB_Total;

		tDiff = tRGB_Magicke_R*(tRGB_Delta.R*tRGB_Delta.R)+tRGB_Magicke_G*(tRGB_Delta.G*tRGB_Delta.G)+tRGB_Magicke_B*(tRGB_Delta.B*tRGB_Delta.B);

		// If the current color in PLAYPAL is an exact match with iRGB,
		// return the index of that current color.
		if (tDiff == 0)
		{
			tBestMatchIndex = i;
			colorchecklog << "Exact match found with index " << tBestMatchIndex << " Palettecolor RGB {" << (int)iPalette.Colors[i].R << ',' << (int)iPalette.Colors[i].G << ',' << (int)iPalette.Colors[i].B << '}' << " iRGB RGB {" << (int)iRGB.R << ',' << (int)iRGB.G << ',' << (int)iRGB.B << '}' << endl;

			return tBestMatchIndex;
		}

		else if (tDiff < tMin_Diff)
		{
			tMin_Diff = tDiff;
			tBestMatchIndex = i;
		}
	}
	// we have not found any perfect matches to iRGB, and we have
	// went through the entire palette. Return the best match we've found.

	colorchecklog << "index " << tBestMatchIndex << " Palettecolor RGB {" << (int)iPalette.Colors[tBestMatchIndex].R << ',' << (int)iPalette.Colors[tBestMatchIndex].G << ',' << (int)iPalette.Colors[tBestMatchIndex].B << '}' << " iRGB RGB {" << (int)iRGB.R << ',' << (int)iRGB.G << ',' << (int)iRGB.B << '}' << " with diff " << tMin_Diff << endl;
	return tBestMatchIndex;
}

// Convert an RGB Gradient to a colormap row.

// i.e., convert a RGB gradient to Doom format within the given palette iPalette.

// a "row" in this case is the full set of 32 indexes for a given color.
ColorMapRow ConvertRGBRowToIndexRow(RGBColorMapRow iRGBColorMap, Pal iPalette)
{
    // set to find the best match in R, G, and B.
    // if you weigh one dimension over another you will get different results.
    ColorMapRow tColorMapRow;

    for(int tCMRow = 0; tCMRow < 34; tCMRow++)
    {
		int tSearchResult = 255;
		colorchecklog << '[' << tCMRow << "]: ";
		//tSearchResult = FindNearestIndexAlt(iRGBColorMap.Colors[tCMRow],iPalette);
		tSearchResult = FindNearestIndex(iRGBColorMap.Colors[tCMRow],iPalette);

        tColorMapRow.Indexes[tCMRow] = tSearchResult;
    }

    return tColorMapRow;
}

// Make a colormap row for the given RGB color iColor.
// Makes a gradient from that color to black and converts it to a colormap row.

ColorMapRow MakeColorMapRow(Pal iPalette, RGB iColor)
{
// 1. make 32 pix gradient from iColor to black
    RGBColorMapRow tRGBColorMapRow = MakeRGBGradient(iColor);
    LogRGBColorMapRow(tRGBColorMapRow);

// 2. For each pixel in the gradient, find the nearest match to iPalette
    ColorMapRow tColorMapRow = ConvertRGBRowToIndexRow(tRGBColorMapRow,iPalette);
    LogColorMapRow(tColorMapRow);

    return tColorMapRow;

}

// Colormap file class. Contains a member function to map colormap rows to it.

// Done mostly because I hate the idea of passing a pointer to an array.

// there are 34 rows of colormaps. 32 for brightness and 2 for special cases
// the COLORMAP file is 256(W) x 32(H)
class COLORMAP_File
{
    public:
    unsigned char indexes[34][256]; //34 rows of 256 colors.

    // note that iRowIndex means the color to map these indexes to
    // runs from 0 to 255
    void ColorMapRowToColorMap(int iRowColorIndex, ColorMapRow iColorMapRow)
    {
        for(int t = 0; t < 34; t++)
        {
            indexes[t][iRowColorIndex] = iColorMapRow.Indexes[t];
        }
    }
};

// Write a colormap file to disk.

bool WriteCOLORMAPFile(COLORMAP_File iCM, string iFileName)
{
    ofstream tempfile;
    tempfile.open(iFileName.c_str(), ios::binary);
    if(!tempfile)
    {
        return false;
    }

    tempfile.write((char*)&iCM,sizeof(COLORMAP_File));
    return true;
}

int main()
{
    // general debugging. For testing/development use only.

    // TODO: Add Verbose mode option
    debuglog.open("log.txt");

    // monitors the conversion from RGB gradients to indexed color gradients.
    // For testing/development use only

    // TODO: Add verbose mode option

    // open input file

    // TODO: Add inputfile string parameter
    colorchecklog.open("colorcheck.txt");

    PLAYPAL tPal;
    tPal = ReadPaletteFile("C:\\PAL\\PLAYPAL.pal");

    //Debugging only: Write back the palette we just read in.
    //WritePaletteFile(tPal, "output.pal");

    COLORMAP_File tColormap_file;

    // Testing only: For all 256 colors, make a colormap row and map it to the
    // Colormap

    // when this is reaching completion this for loop will not be in main().

    // testing a few color ranges at a time

     int LowerLimit = 0;
    int UpperLimit = 255;


    for(int i = 0; i < 256; i++)
    {
        int tTempOverride = i;
        if((tTempOverride > UpperLimit) || (tTempOverride < LowerLimit))
        {
            tTempOverride = 0;
        }

        cout << "Row " << tTempOverride << " of 255" << endl;
        colorchecklog << "Row " << tTempOverride << " of 255" << endl;

        ColorMapRow tColorMapRow;


        tColorMapRow = MakeColorMapRow(tPal.Palettes[0],tPal.Palettes[0].Colors[tTempOverride]);
        tColormap_file.ColorMapRowToColorMap(tTempOverride,tColorMapRow);
    }

    WriteCOLORMAPFile(tColormap_file,"Colormaptest.cm");

    return 0;
}
